
class Painter:
    def __init__(self):
        pass

    def strip(self, end1, end2, width, layer):
        pass

    def via(self, position):
        pass

    def pad(self, position, number, layer):
        pass

class Kicad(Painter):
    hole_min = .3
    ring_min = .1524

    layer_maps = [
        ["F.Cu"],
        ["F.Cu", "B.Cu"],
        ["F.Cu", "In1.Cu", "B.Cu"],
        ["F.Cu", "In1.Cu", "In2.Cu", "B.Cu"],
    ]
    def __init__(self, ant, supp = ""):
        import kicad_mod as Ki

        self.layer_map = self.layer_maps[ant.layers]

        if supp:
            supp = "_" + supp
        self.module = Ki.Module(
            "NFC-Antenna_%dx%dmm_%dx%d%s" % (ant.width, ant.height, ant.layers, ant.turns, supp),
            "NFC antenna", "virtual")
        self.trace_width = ant.trace.width
        self.hole_diameter = max(self.trace_width / math.pi, self.hole_min)
        self.ring_diameter = max(self.trace_width, self.hole_diameter + self.ring_min * 2)

    def strip(self, end1, end2, layer):
        import kicad_mod as Ki

        self.module.append(Ki.Line(end1, end2, self.trace_width, self.layer_map[layer]))

    def via(self, position):
        import kicad_mod as Ki

        self.module.append(Ki.Via(position, self.hole_diameter, self.ring_diameter))

    def pad(self, position, number, layer):
        import kicad_mod as Ki

        self.module.append(Ki.Connection(position, self.ring_diameter, number, self.layer_map[layer]))
